package test;

import java.io.InputStream;
import java.io.IOException;

abstract public class CHARLISTImpl extends PeanoConstructor
{
  static CHARLIST fromString(String str)
  {
    aterm.ATerm trm = getStaticPeanoFactory().parse(str);
    return fromTerm(trm);
  }
  static CHARLIST fromTextFile(InputStream stream) throws aterm.ParseError, IOException
  {
    aterm.ATerm trm = getStaticPeanoFactory().readFromTextFile(stream);
    return fromTerm(trm);
  }
  public boolean isEqual(CHARLIST peer)
  {
    return term.isEqual(peer.toTerm());
  }
  public static CHARLIST fromTerm(aterm.ATerm trm)
  {
    CHARLIST tmp;
    if ((tmp = CHARLIST_String.fromTerm(trm)) != null) {
      return tmp;
    }


    throw new RuntimeException("This is not a CHARLIST: " + trm);
  }

  public boolean isString()
  {
    return false;
  }

  public boolean hasString()
  {
    return false;
  }

  public String getString()
  {
     throw new RuntimeException("This CHARLIST has no String");
  }

  public CHARLIST setString(String _string)
  {
     throw new RuntimeException("This CHARLIST has no String");
  }


}

