package test;

abstract public class Nat_SucImpl
extends Nat
{
  static private aterm.ATerm pattern = null;

  protected aterm.ATerm getPattern() {
    return pattern;
  }
  private static int index_wsAfterSuc = 0;
  private static int index_wsAfterParenOpen = 1;
  private static int index_pred = 2;
  private static int index_wsAfterPred = 3;
  public shared.SharedObject duplicate() {
    Nat_Suc clone = new Nat_Suc();
     clone.init(hashCode(), getAnnotations(), getAFun(), getArgumentArray());
    return clone;
  }

  protected aterm.ATermAppl make(aterm.AFun fun, aterm.ATerm[] i_args, aterm.ATermList annos) {
    return getPeanoFactory().makeNat_Suc(fun, i_args, annos);
  }
  static public void initializePattern()
  {
    pattern = getStaticFactory().parse("appl(prod([lit(\"suc\"),cf(opt(layout)),lit(\"(\"),cf(opt(layout)),cf(sort(\"Nat\")),cf(opt(layout)),lit(\")\")],cf(sort(\"Nat\")),attrs([term(cons(\"suc\"))])),[lit(\"suc\"),<term>,lit(\"(\"),<term>,<term>,<term>,lit(\")\")])");
  }

  static public Nat fromTerm(aterm.ATerm trm)
  {
    java.util.List children = trm.match(pattern);

    if (children != null) {
      Nat tmp = getStaticPeanoFactory().makeNat_Suc(OptLayout.fromTerm( (aterm.ATerm) children.get(0)), OptLayout.fromTerm( (aterm.ATerm) children.get(1)), Nat.fromTerm( (aterm.ATerm) children.get(2)), OptLayout.fromTerm( (aterm.ATerm) children.get(3)));
      tmp.setTerm(trm);
      return tmp;
    }
    else {
      return null;
    }
  }
  public boolean isSuc()
  {
    return true;
  }

  public boolean hasWsAfterSuc()
  {
    return true;
  }

  public boolean hasWsAfterParenOpen()
  {
    return true;
  }

  public boolean hasPred()
  {
    return true;
  }

  public boolean hasWsAfterPred()
  {
    return true;
  }

  public OptLayout getWsAfterSuc()
  {
    return (OptLayout) this.getArgument(index_wsAfterSuc) ;
  }

  public Nat setWsAfterSuc(OptLayout _wsAfterSuc)
  {
    return (Nat) super.setArgument(_wsAfterSuc, index_wsAfterSuc);
  }

  public OptLayout getWsAfterParenOpen()
  {
    return (OptLayout) this.getArgument(index_wsAfterParenOpen) ;
  }

  public Nat setWsAfterParenOpen(OptLayout _wsAfterParenOpen)
  {
    return (Nat) super.setArgument(_wsAfterParenOpen, index_wsAfterParenOpen);
  }

  public Nat getPred()
  {
    return (Nat) this.getArgument(index_pred) ;
  }

  public Nat setPred(Nat _pred)
  {
    return (Nat) super.setArgument(_pred, index_pred);
  }

  public OptLayout getWsAfterPred()
  {
    return (OptLayout) this.getArgument(index_wsAfterPred) ;
  }

  public Nat setWsAfterPred(OptLayout _wsAfterPred)
  {
    return (Nat) super.setArgument(_wsAfterPred, index_wsAfterPred);
  }

  public aterm.ATermAppl setArgument(aterm.ATerm arg, int i) {
    switch(i) {
      case 0:
        if (! (arg instanceof OptLayout)) { 
          throw new RuntimeException("Argument 0 of a Nat_Suc should have type OptLayout");
        }
        break;
      case 1:
        if (! (arg instanceof OptLayout)) { 
          throw new RuntimeException("Argument 1 of a Nat_Suc should have type OptLayout");
        }
        break;
      case 2:
        if (! (arg instanceof Nat)) { 
          throw new RuntimeException("Argument 2 of a Nat_Suc should have type Nat");
        }
        break;
      case 3:
        if (! (arg instanceof OptLayout)) { 
          throw new RuntimeException("Argument 3 of a Nat_Suc should have type OptLayout");
        }
        break;
      default: throw new RuntimeException("Nat_Suc does not have an argument at " + i );
    }
    return super.setArgument(arg, i);
  }
  protected int hashFunction() {
    int c = getArgument(2).hashCode() + (getAnnotations().hashCode()<<8);
    int a = 0x9e3779b9;
    int b = 0x9e3779b9;
    a += (getArgument(3).hashCode() << 24);
    a += (getArgument(2).hashCode() << 16);
    a += (getArgument(1).hashCode() << 8);
    a += (getArgument(0).hashCode() << 0);

    a -= b; a -= c; a ^= (c >> 13);
    b -= c; b -= a; b ^= (a << 8);
    c -= a; c -= b; c ^= (b >> 13);
    a -= b; a -= c; a ^= (c >> 12);
    b -= c; b -= a; b ^= (a << 16);
    c -= a; c -= b; c ^= (b >> 5);
    a -= b; a -= c; a ^= (c >> 3);
    b -= c; b -= a; b ^= (a << 10);
    c -= a; c -= b; c ^= (b >> 15);

    return c;
  }
}
